/*! Built with http://stenciljs.com */
import { h } from '../ip-slider.core.js';
var IpSLider = /** @class */ (function () {
    function IpSLider() {
        this.value = 0;
        this.min = 0;
        this.max = 100;
        this.step = 1;
        this.disabled = false;
    }
    IpSLider.prototype.componentDidLoad = function () {
        this.range = this.el.shadowRoot.querySelector('input');
        this.setAttributes();
    };
    IpSLider.prototype.componentDidUpdate = function () {
        this.setAttributes();
    };
    IpSLider.prototype.setAttributes = function () {
        this.el.setAttribute('aria-disabled', "" + this.disabled);
        this.el.setAttribute('aria-valuemax', "" + this.max);
        this.el.setAttribute('aria-valuemin', "" + this.min);
        this.el.setAttribute('aria-valuenow', "" + +this.value);
        this.el.setAttribute('value', "" + +this.value);
    };
    IpSLider.prototype.onInput = function (srcEvent) {
        srcEvent.stopPropagation();
        var _a = this.range, value = _a.value, min = _a.min, max = _a.max, step = _a.step;
        this.value = +value;
        this.input.emit({
            srcEvent: srcEvent,
            value: +value,
            min: +min,
            max: +max,
            step: +step
        });
    };
    IpSLider.prototype.render = function () {
        var _this = this;
        return (h("input", { type: "range", onInput: function (ev) { return _this.onInput(ev); }, disabled: this.disabled, min: this.min, max: this.max, step: this.step, value: this.value }));
    };
    Object.defineProperty(IpSLider, "is", {
        get: function () { return "ip-slider"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IpSLider, "encapsulation", {
        get: function () { return "shadow"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IpSLider, "properties", {
        get: function () {
            return {
                "disabled": {
                    "type": Boolean,
                    "attr": "disabled",
                    "reflectToAttr": true
                },
                "el": {
                    "elementRef": true
                },
                "max": {
                    "type": Number,
                    "attr": "max"
                },
                "min": {
                    "type": Number,
                    "attr": "min"
                },
                "step": {
                    "type": Number,
                    "attr": "step"
                },
                "value": {
                    "type": Number,
                    "attr": "value",
                    "mutable": true
                }
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IpSLider, "events", {
        get: function () {
            return [{
                    "name": "input",
                    "method": "input",
                    "bubbles": true,
                    "cancelable": true,
                    "composed": true
                }];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IpSLider, "style", {
        get: function () { return ":host{--primary:#66c56b;--secondary:#227a1f;--drag-cursor:grab;--draging-cursor:grabbing;--track-height:4px;--track-radius:2px;--track-border-width:1px;--track-border-color:rgba(143, 143, 143, 0.26);--thumb-height:17px;--thumb-width:17px;--thumb-radius:50%;--thumb-border-width:2px;--thumb-border-color:rgba(143, 143, 143, 0.26);--transition-timing-function:cubic-bezier(0.25, 0.8, 0.25, 1);display:inline-block;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;outline:0;vertical-align:middle;height:auto;min-width:128px}:host input{padding:0;margin:0;top:50%;left:50%;position:absolute;width:100%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);-webkit-appearance:none;background:0 0}:host input::-moz-focus-outer{border:0}:host input:focus{outline:0}:host input:focus::-webkit-slider-runnable-track{background:var(--primary)}:host input:focus::-ms-fill-lower{background:var(--primary)}:host input:focus::-ms-fill-upper{background:var(--primary)}:host input::-webkit-slider-runnable-track{cursor:default;-webkit-box-sizing:border-box;box-sizing:border-box;height:var(--track-height);-webkit-transition:all .4s var(--transition-timing-function);transition:all .4s var(--transition-timing-function);border:var(--track-border-width) solid var(--track-border-color);border-radius:var(--track-radius);width:100%;-webkit-box-shadow:0 0 1px rgba(0,0,0,.2),0 0 0 rgba(13,13,13,.2);box-shadow:0 0 1px rgba(0,0,0,.2),0 0 0 rgba(13,13,13,.2);background:var(--primary)}:host input::-webkit-slider-runnable-track:active{cursor:var(--draging-cursor)}:host input::-webkit-slider-thumb{-webkit-box-shadow:1px 1px 0 rgba(0,0,0,.2),0 0 1px rgba(13,13,13,.2);box-shadow:1px 1px 0 rgba(0,0,0,.2),0 0 1px rgba(13,13,13,.2);background:var(--secondary);border:var(--thumb-border-width) solid var(--thumb-border-color);border-radius:var(--thumb-radius);cursor:var(--drag-cursor);height:calc(var(--thumb-height) + 0px);width:calc(var(--thumb-width) + 0px);margin-top:calc(var(--track-height)/ 2.1 - (var(--thumb-height) + var(--thumb-border-width) + 0px)/ 1.9);-webkit-appearance:none}:host input::-webkit-slider-thumb:active{cursor:var(--draging-cursor)}:host input::-moz-range-track{box-shadow:0 0 1px rgba(0,0,0,.2),0 0 0 rgba(13,13,13,.2);cursor:default;box-sizing:border-box;height:var(--track-height);-webkit-transition:all .4s var(--transition-timing-function);transition:all .4s var(--transition-timing-function);border:var(--track-border-width) solid var(--track-border-color);border-radius:var(--track-radius);width:100%;background:var(--primary)}:host input::-moz-range-track:active{cursor:var(--draging-cursor)}:host input::-moz-range-thumb{box-shadow:1px 1px 0 rgba(0,0,0,.2),0 0 1px rgba(13,13,13,.2);background:var(--secondary);border:var(--thumb-border-width) solid var(--thumb-border-color);border-radius:var(--thumb-radius);cursor:var(--drag-cursor);height:calc(var(--thumb-height) + -4px);width:calc(var(--thumb-width) + -4px);margin-top:calc(var(--track-height)/ 2.1 - (var(--thumb-height) + var(--thumb-border-width) + -4px)/ 1.9)}:host input::-moz-range-thumb:active{cursor:var(--draging-cursor)}:host input::-ms-track{cursor:default;box-sizing:border-box;height:var(--track-height);-webkit-transition:all .4s var(--transition-timing-function);transition:all .4s var(--transition-timing-function);border:var(--track-border-width) solid var(--track-border-color);border-radius:var(--track-radius);width:100%;background:0 0;border-color:transparent;color:transparent}:host input::-ms-track:active{cursor:var(--draging-cursor)}:host input::-ms-fill-lower{box-shadow:0 0 1px rgba(0,0,0,.2),0 0 0 rgba(13,13,13,.2);background:rgba(0,0,0,.26);border-radius:calc(var(--track-radius) * 2)}:host input::-ms-fill-upper{box-shadow:0 0 1px rgba(0,0,0,.2),0 0 0 rgba(13,13,13,.2);background:var(--primary);border-radius:calc(var(--track-radius) * 2)}:host input::-ms-thumb{box-shadow:1px 1px 0 rgba(0,0,0,.2),0 0 1px rgba(13,13,13,.2);background:var(--secondary);border:var(--thumb-border-width) solid var(--thumb-border-color);border-radius:var(--thumb-radius);cursor:var(--drag-cursor);height:calc(var(--thumb-height) + -4px);width:calc(var(--thumb-width) + -4px);margin-top:calc(var(--track-height)/ 2.1 - (var(--thumb-height) + var(--thumb-border-width) + -4px)/ 1.9);margin-top:calc(var(--track-height)/ 4)}:host input::-ms-thumb:active{cursor:var(--draging-cursor)}:host input:disabled::-webkit-slider-thumb{cursor:not-allowed;opacity:.9}:host input:disabled::-moz-range-thumb{cursor:not-allowed;opacity:.9}:host input:disabled::-ms-thumb{cursor:not-allowed;opacity:.9}:host input:disabled::-webkit-slider-runnable-track{cursor:not-allowed;opacity:.9}:host input:disabled::-ms-fill-lower{cursor:not-allowed;opacity:.9}:host input:disabled::-ms-fill-upper{cursor:not-allowed;opacity:.9}"; },
        enumerable: true,
        configurable: true
    });
    return IpSLider;
}());
export { IpSLider as IpSlider };
